$fn=50;

// permet d'ajouter des supports aux 4 coins pour éviter le warping
support=false;


partie_inferieure();
*translate ([0,0,17]) mirror ([0,0,-1]) partie_superieure();


module partie_superieure()
{
union()
    {
difference()
{
box (109,69.5,8.5,2); 
stries();
difference(){
translate ([2.5,2,2]) cube ([104,64.5,7]);
translate ([9,27.5,0]) passage_vis();
translate ([99.5,27.5,0]) passage_vis();
translate ([12,2,0]) cube ([1,17,8.5]); 
difference(){
translate ([1,17,0]) cube ([106,2,8.5]);
translate ([26,16.9,7.5]) cube ([66,2.2,3]);}
}  
translate ([14,-0.1,2]) cube ([89,2.2,7.5]);
translate ([3,69,0]) cube ([103,0.5,9]);
translate ([9,27.5,0]) tete_vis();
translate ([99.5,27.5,0]) tete_vis();
}
if (support==true) support_impression();
}}


module partie_inferieure()
{
union(){
difference()
{
box (109,69.5,8.5,2);
stries();
difference(){
translate ([2.5,2,2]) cube ([104,64.5,8.5]);
translate ([9,27.5,0]) fixvis();
translate ([99.5,27.5,0]) fixvis();
cube ([13,17,7]);
translate ([9,59,0]) fixvis();
translate ([99.5,59,0]) fixvis();
translate ([21,17,0]) cube ([3,5,6.5]);
translate ([94,17,0]) cube ([3,5,6.5]);
difference(){
translate ([1,17,0]) cube ([106,2,8.5]);
translate ([26,16.9,6]) cube ([66,2.2,3]);}
}  
translate ([14,-0.1,2]) cube ([89,2.2,7]);
translate ([3,69,2]) cube ([103,0.5,7]);
hull(){
translate ([8,0,2]) rotate ([-90,0,0]) cylinder (d=1,h=10);
translate ([4.25,0,0]) cube ([7.5,10,1.2]);}
}
translate ([2.5,64,0]) cube ([6,2.5,11]);
translate ([100.5,64,0]) cube ([6,2.5,11]);
translate ([2.5,2,2]) cube ([2,5,8]);
translate ([104.5,2,0]) cube ([2,5,10]);
translate ([11.5,2,2]) cube ([1.5,15,6.5]);
if (support==true) support_impression();
}}


// support d'impression
module support_impression()
{
translate ([0,69,0]) cylinder (d=10,h=0.4);
translate ([108,69,0]) cylinder (d=10,h=0.4);
translate ([107,1,0]) cylinder (d=10,h=0.4);
translate ([1,1,0]) cylinder (d=10,h=0.4);
}


module fixvis()
{
difference(){
 union(){
 cylinder (d=6.5,h=6.5);
 translate ([0,0,1.5]) cylinder (d2=6.5,d1=10,h=3);}
 translate ([0,0,2]) cylinder (d=2,h=7);
 }}

module stries()
{
difference(){
translate ([0,41.5,0]) cube ([1,23.5,15]);
for (i=[0:8]) translate ([1.25,41.5+2.93*i,0]) cylinder (d=2.5,h=15);
}


difference(){
translate ([108,41.5,0]) cube ([1,23.5,15]);
for (i=[0:8]) translate ([107.75,41.5+2.93*i,0]) cylinder (d=2.5,h=15);
}}


module pcb()
{
  difference(){
 union(){
translate ([0,17.5,0]) cube ([100,44,1.7]);
translate ([22,0,0]) cube ([66,61.5,1.7]);} 
translate ([5,26,-0.1]) cylinder (d=4,h=2);
translate ([95,26,-0.1]) cylinder (d=4,h=2);
}}

module passage_vis()
{
    union(){
 cylinder (d=6.5,h=8.5);
translate ([0,0,1.5]) cylinder (d2=6.5,d1=10,h=3);    
}}

module passage_vis2()
{
    union(){
 cylinder (d=6.5,h=12.5);
translate ([0,0,1.5]) cylinder (d2=6.5,d1=10,h=3);    
}}

module tete_vis()
{
    union(){
  cylinder (d=3.3,h=14);  
  cylinder (d=5.8,h=1);  
  translate ([0,0,1])  cylinder (d1=5.8,d2=3.2,h=1.5);
}}


module box (long,larg,haut,r)
{
    hull(){
    translate ([r,r,r]) sphere (r=r);
    translate ([r,r,r]) cylinder (r=r,h=haut-r);
    translate ([long-r,r,r]) sphere (r=r);
    translate ([long-r,r,r]) cylinder (r=r,h=haut-r);
    translate ([r,larg-r,r]) sphere (r=r);
    translate ([r,larg-r,r]) cylinder (r=r,h=haut-r);        
    translate ([long-r,larg-r,r]) sphere (r=r);    
     translate ([long-r,larg-r,r]) cylinder (r=r,h=haut-r);
    }   
}